<cfcomponent hint="A cat component.">

	<cfset variables.color = "" />
	<cfset variables.weight = "" />
	<cfset variables.name = "" />
	
	<cffunction name="describe"
		access="public"
		hint="I return a description of the cat."
		output="false"
		returntype="string">
		<cfreturn "I am a #getColor()# cat weighing in at #getWeight()# pounds.  My name is #getName()#!" />
	</cffunction>
	
	<!--- set color --->
    <cffunction name="setColor"
		access="public"
		output="false"
		returntype="cat"
		hint="Sets the color of the cat">
		<cfargument name="color"
			hint="The color of the cat."
			required="yes"
			type="string" />
		<!--- set the variables.color value to arguments.color --->
		<cfset variables.color = arguments.color />
		<cfreturn this />
    </cffunction>
	
	<!--- get color --->
    <cffunction name="getColor"
		access="public"
		output="false"
		returntype="string"
		hint="Gets the color of the cat">
		<!--- return the value of variables.color --->
		<cfreturn variables.color />
    </cffunction>
	
	<!--- set name --->
    <cffunction name="setName"
		access="public"
		output="false"
		returntype="Cat"
		hint="Gets the name of the cat">
		<cfargument name="name"
			hint="The name of the cat."
			required="yes"
			type="string" />
		<!--- set the variables.name value to arguments.name --->
		<cfset variables.name = arguments.name />
		<cfreturn this />
    </cffunction>
	
	<!--- get name --->
    <cffunction name="getName"
		access="public"
		output="false"
		returntype="string"
		hint="Sets the name of the cat">
		<!--- return the value of variables.name --->
		<cfreturn variables.name />
    </cffunction>
	
	<!--- set weight --->
    <cffunction name="setWeight"
		access="public"
		output="false"
		returntype="Cat"
		hint="Sets the weight of the cat">
	<cfargument name="weight"
			hint="The weight of the cat in pounds.  Must be between 1 and for really fat cats 35 pounds."
			required="yes"
			type="numeric" /> 
<cfdump var="#arguments[1]#"><cfabort>
		<!--- verify the value of weight --->
		<cfif arguments.weight LT 1 OR arguments.weight GT 35>
			<cfthrow
				message="Invalid weight (#arguments.weight#).  A cat must weigh between 1 and 35 pounds." />
		</cfif>
		<!--- set the variables.weight value to arguments.weight --->
		<cfset variables.weight = arguments.weight />
		<cfreturn this />
    </cffunction>
	
	<!--- get weight --->
    <cffunction
		name="getWeight"
		access="public"
		output="false"
		returntype="string"
		hint="Gets the weight of the cat">
		<!--- return the value of variables.weight --->
		<cfreturn variables.weight />
    </cffunction>
</cfcomponent>